<template>
<div>
  <v-form @submit.prevent="registrar" ref="form" lazy-validation>
    <v-text-field type="email" label="Email" v-model="email" :rules="rules.email"/>
    <v-text-field label="Nome Completo" v-model="name" :rules="rules.name"/>
    <v-text-field
      :type="show_password ? 'text' : 'password'"
      label="Password"
      v-model="password"
      @click:append="show_password = !show_password"
      :append-icon="show_password ? 'mdi-eye' : 'mdi-eye-off'"
      :rules="rules.password"
    />
    <v-text-field
      :type="show_password ? 'text' : 'password'"
      label="Confirme seu password"
      v-model="password_confirmation"
      @click:append="show_password = !show_password"
      :rules="rules.password_confirmation"
      :append-icon="show_password ? 'mdi-eye' : 'mdi-eye-off'"
    />

    <slot/>
  </v-form>

  <alert v-if="alert.showAlert" :show="alert.showAlert" :text="alert.msg" :type="alert.type" v-on:snackbar="alert.showAlert = false"/>
</div>
</template>

<script>
export default {
  name: 'FormRegister',
  data () {
    return {
      name: null,
      email: null,
      password: null,
      password_confirmation: null,
      show_password: false,

      alert: {
        showAlert: false,
        msg: '',
        type: ''
      },

      rules: {
        name: [
          v => !!v || 'Digite seu nome'
        ],
        email: [
          v => !!v || 'Digite seu endereço de email',
          v => /.+@.+\..+/.test(v) || 'Endereço de mail inválido'
        ],
        password: [
          v => !!v || 'Preenchimento obrigatório',
          v => (v && v.length >= 6) || 'Mínimo de 6 carácteres'
        ],
        password_confirmation: [
          v => !!v || 'Preenchimento obrigatório',
          v => (v && v.length >= 6) || 'Mínimo de 6 carácteres',
          v => (v === this.password) || 'Não coincide com a senha'
        ]
      }
    }
  },
  methods: {
    registrar () {
      if (this.$refs.form.validate()) {
        this.$emit('loading', true)
        this.$axios.post('register', {
          name: this.name,
          email: this.email,
          password: this.password,
          password_confirmation: this.password_confirmation
        }).then((r) => {
          if (r.status) {
            this.$router.push('/register/registered')
          }
          this.$emit('loading', false)
        }).catch((e) => {
          this.$emit('loading', false)
          const erros = e.response.data
          if (erros) {
            for (const erro in erros.errors) {
              this.alertError(erros.errors[erro][0], 'error')
            }
          }

          if (erros.msg) {
            this.alertError(erros.msg, 'error')
          }
        })
      }
    },
    alertError (erro = null, type = 'success') {
      if (this.alert.showAlert) {
        this.alert.showAlert = false
      }
      this.alert.showAlert = !this.alert.showAlert
      this.alert.msg = erro
      this.alert.type = type
    }
  }
}
</script>

<style>

</style>
